//
pub mod commit;
pub mod file;
pub mod forge;
mod generation;
mod git_ref;
mod git_remote;
pub mod graph;
pub mod push;
mod repo_details;
pub mod repository;
mod user_notification;
pub mod validation;

#[cfg(test)]
mod tests;

pub use commit::Commit;
pub use forge::ForgeLike;
pub use generation::Generation;
#[allow(clippy::module_name_repetitions)]
pub use git_ref::GitRef;
#[allow(clippy::module_name_repetitions)]
pub use git_remote::GitRemote;
pub use repo_details::RepoDetails;
pub use repository::RepositoryFactory;
pub use user_notification::UserNotification;

#[cfg(test)]
#[must_use]
pub fn repo_details(
    n: u32,
    generation: Generation,
    forge: super::ForgeDetails,
    repo_config: Option<super::RepoConfig>,
    gitdir: super::GitDir,
) -> RepoDetails {
    RepoDetails {
        generation,
        repo_alias: super::common::repo_alias(n),
        repo_path: super::common::repo_path(n),
        gitdir,
        branch: super::common::branch_name(n),
        forge,
        repo_config,
    }
}
