//
use super::*;
use crate::err;

#[test]
fn push_is_error_should_error() {
    let commit = given::a_commit();
    let fs = given::a_filesystem();
    let repo_config = given::a_repo_config();
    let (mut open_repository, repo_details) = given::an_open_repository(&fs);
    expect::fetch_ok(&mut open_repository);
    expect::push(&mut open_repository, Err(err!("on-push")));
    let_assert!(
        Err(err) = branch::advance_main(commit, &repo_details, &repo_config, &open_repository)
    );
    assert_eq!(err.to_string(), "on-push");
}

#[test]
fn push_is_ok_should_ok() {
    let commit = given::a_commit();
    let fs = given::a_filesystem();
    let repo_config = given::a_repo_config();
    let (mut open_repository, repo_details) = given::an_open_repository(&fs);
    expect::fetch_ok(&mut open_repository);
    expect::push_ok(&mut open_repository);
    assert!(branch::advance_main(commit, &repo_details, &repo_config, &open_repository).is_ok());
}
